/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wp500patchtool.controllers;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ResourceBundle;
import javafx.application.Platform;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ProgressIndicator;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.stage.FileChooser;
import javafx.stage.Stage;

/**
 * FXML Controller class
 *
 * @author TEST
 */
public class HomeScreenController implements Initializable {

    @FXML
    private TextField textFieldOfIpAddress;
    @FXML
    private TextField textFieldOfUserName;
    @FXML
    private TextField textFieldOfPassword;
    @FXML
    private Button uploadFileBtn;
    @FXML
    private Button rebootBtn;
    @FXML
    private TextArea consoleTextArea;
    String ip = null;
    String username = null;
    String password = null;
    @FXML
    private Button installPatchBtn;
    // public File file;
    private File selectedFile;
    private ProgressIndicator loader;
    @FXML
    private Label fileLabel;
    @FXML
    private Button chooseFileBtn;

    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
        installPatchBtn.setDisable(true);
        rebootBtn.setDisable(true);

    }

    @FXML
    private void uploadFileAction(ActionEvent event) {
        System.out.println("Upload file action triggered.");
        uploadFileBtn.setDisable(true);
        consoleTextArea.clear();
        ip = textFieldOfIpAddress.getText().trim();
        username = textFieldOfUserName.getText().trim();
        password = textFieldOfPassword.getText().trim();

        if (ip.isEmpty() || username.isEmpty() || password.isEmpty()) {
            System.out.println("Validation failed: IP, username, or password is empty.");
            logToConsole("All fields should be mandatory.");
            uploadFileBtn.setDisable(false);
            return;
        }

        if (selectedFile != null) {
            System.out.println("Uploading file: " + selectedFile.getAbsolutePath());
            boolean uploadSuccess = uploadFile(selectedFile, ip);

            if (uploadSuccess) {
                System.out.println("File uploaded successfully.");
                logToConsole("File uploaded successfully.");
                installPatchBtn.setDisable(false);
            } else {
                System.out.println("File upload failed.");
                logToConsole("File upload failed.");
                installPatchBtn.setDisable(true);
                uploadFileBtn.setDisable(false);
            }
        } else {
            System.out.println("No file selected.");
            logToConsole("No file selected. Please choose a file first.");
            uploadFileBtn.setDisable(false);
        }
    }

    private boolean uploadFile(File file, String ip) {
        System.out.println("Executing uploadFile method with file: " + file.getAbsolutePath());
        try {
            String command = String.format(
                    "pscp -pw %s \"%s\" %s@%s:/tmp/",
                    password, file.getAbsolutePath(), username, ip
            );
            System.out.println("Executing command: " + command);

            ProcessBuilder processBuilder = new ProcessBuilder("cmd", "/c", command);
            processBuilder.redirectErrorStream(true);
            Process process = processBuilder.start();

            // Capture the output
            try (BufferedReader reader = new BufferedReader(new InputStreamReader(process.getInputStream()))) {
                String line;
                while ((line = reader.readLine()) != null) {
                    System.out.println(line); // Log process output
                    logToConsole(line);
                }
            }

            int exitCode = process.waitFor();
            System.out.println("Command executed with exit code: " + exitCode);
            return exitCode == 0;
        } catch (IOException | InterruptedException e) {
            System.out.println("Error during file upload: " + e.getMessage());
            logToConsole("Error during file upload: " + e.getMessage());
            e.printStackTrace();
            return false;
        }
    }

    @FXML
    private void rebootDeviceAction(ActionEvent event) {
        System.out.println("Reboot device action triggered.");
        try {
            rebootDevice(ip, username, password);
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
            logToConsole("Error: " + e.getMessage());
            e.printStackTrace();
        }
    }
//

    private void removeDBFromDevice(String ip, String userName, String password) {
        System.out.println("Removing database from device with IP: " + ip);
        try {
            String command = String.format(
                    "plink -pw %s %s@%s sudo rm /usr/bin/wp_500DbFile.db",
                    password,
                    userName,
                    ip
            );
            System.out.println("Executing command: " + command);
            Process process = Runtime.getRuntime().exec(command);
            int exitCode = process.waitFor();
            System.out.println("Database removal exit code: " + exitCode);

            if (exitCode == 0) {
                logToConsole("Database removal successful.");
            } else {
                logToConsole("Database removal failed with exit code: " + exitCode);
            }
        } catch (IOException e) {
            System.out.println("Error during database removal: " + e.getMessage());
            logToConsole("Error during database removal: " + e.getMessage());
            e.printStackTrace();
        } catch (InterruptedException e) {
            System.out.println("Process interrupted: " + e.getMessage());
            logToConsole("Process interrupted: " + e.getMessage());
            e.printStackTrace();
        }
    }
//

    private void rebootDevice(String ip, String username, String password) {
        System.out.println("Starting device reboot for IP: " + ip);
        rebootBtn.setDisable(true);
        try {
            String command = String.format(
                    "plink -pw %s %s@%s sudo reboot",
                    password,
                    username,
                    ip
            );
            System.out.println("Executing command: " + command);
            Process process = Runtime.getRuntime().exec(command);
            int exitCode = process.waitFor();
            System.out.println("Reboot command exit code: " + exitCode);

            if (exitCode == 0 || exitCode == 1) {
                logToConsole("Reboot command executed successfully.");
                textFieldOfIpAddress.clear();
                textFieldOfPassword.clear();
                textFieldOfUserName.clear();
                installPatchBtn.setDisable(true);
                rebootBtn.setDisable(true);
                uploadFileBtn.setDisable(false);
                chooseFileBtn.setDisable(false);
                fileLabel.setText("");
            } else {
                logToConsole("Reboot command failed with exit code: " + exitCode);
                rebootBtn.setDisable(false);
            }
        } catch (IOException e) {
            System.out.println("Error during reboot: " + e.getMessage());
            logToConsole("Error during reboot: " + e.getMessage());
            rebootBtn.setDisable(false);
            e.printStackTrace();
        } catch (InterruptedException e) {
            System.out.println("Reboot process interrupted: " + e.getMessage());
            logToConsole("Reboot process interrupted: " + e.getMessage());
            rebootBtn.setDisable(false);
            e.printStackTrace();
        }
    }

    private void logToConsole(String message) {
        System.out.println("Logging to console: " + message);
        Platform.runLater(() -> consoleTextArea.appendText(message + "\n"));
    }

    @FXML
    private void installBundleAction(ActionEvent event) {
        System.out.println("Install bundle action triggered.");
        installPatchBtn.setDisable(true);
        if (ip.isEmpty() || username.isEmpty() || password.isEmpty()) {
            System.out.println("Validation failed: IP, username, or password is empty.");
            logToConsole("All fields are mandatory. Please provide IP, username, and password.");
            installPatchBtn.setDisable(false);
            return;
        }

        removeDBFromDevice(ip, username, password);
        if (selectedFile == null) {
            logToConsole("File is not present.");
        }
        boolean success = executeBundleCommand(ip, selectedFile);

        if (success) {
            System.out.println("Bundle installation successful.");
            logToConsole("Bundle installation process completed successfully.");
            rebootBtn.setDisable(false);
        } else {
            System.out.println("Bundle installation failed.");
            logToConsole("Bundle installation process failed.");
            installPatchBtn.setDisable(false);
            rebootBtn.setDisable(true);
        }
    }

    private boolean executeBundleCommand(String ip, File file) {
        System.out.println("Executing bundle command for file: " + file);
        try {

            String command = String.format(
                    "plink -pw %s %s@%s sudo tar -xvf /tmp/%s -C /",
                    password,
                    username,
                    ip,
                    file.getName()
            );
            System.out.println("Executing command: " + command);
            Process process = Runtime.getRuntime().exec(command);
            int exitCode = process.waitFor();
            System.out.println("Bundle command exit code: " + exitCode);

            if (exitCode == 0) {
                logToConsole("Bundle installation completed successfully.");
                return true;
            } else {
                logToConsole("Bundle installation failed with exit code: " + exitCode);
                return false;
            }
        } catch (IOException e) {
            System.out.println("Error during bundle command execution: " + e.getMessage());
            logToConsole("Error during bundle command execution: " + e.getMessage());
            e.printStackTrace();
            return false;
        } catch (InterruptedException e) {
            System.out.println("Bundle command execution interrupted: " + e.getMessage());
            logToConsole("Bundle command execution interrupted: " + e.getMessage());
            e.printStackTrace();
            return false;
        }
    }

    @FXML
    private void chooseFileAction(ActionEvent event) {
        System.out.println("Choose file action triggered.");
        FileChooser fileChooser = new FileChooser();
        fileChooser.getExtensionFilters().add(new FileChooser.ExtensionFilter("TAR Files", "*.tar"));
        fileChooser.setTitle("Select a .tar file");

        selectedFile = fileChooser.showOpenDialog(chooseFileBtn.getScene().getWindow());
        if (selectedFile != null) {
            System.out.println("File selected: " + selectedFile.getName());
            fileLabel.setText("Selected file: " + selectedFile.getName());
            chooseFileBtn.setDisable(true);
        } else {
            System.out.println("No file selected.");
            fileLabel.setText("No file selected.");
            chooseFileBtn.setDisable(false);
        }
    }

}
